MFD_RTR_IP=${MFD_RTR_IP:-10.255.255.254}

source /lib/functions/sysconfig.sh

syslog_iface() {
  if [ -z "${SYSLOGSRV_IF:-}" ]; then
    if sysconfig_enabled netdev_config; then
      SYSLOGSRV_IF=$(sysconfig_metadata netdev_config interface)
    fi

    if [ -z "${SYSLOGSRV_IF:-}" ]; then
      SYSLOGSRV_IF="eth0"
    fi
  fi

  printf "%s\n" "$SYSLOGSRV_IF"
}

calc_static_ip() {
  local iface=${1:-$(syslog_iface)}

  awk '{
    split($1, a, ":");
    printf("10.%d.%d.%d\n", "0x"a[4], "0x"a[5], "0x"a[6]);
  }' </sys/class/net/$iface/address
}
